scala.tools.nsc.backend.jvm

# BCodeAsmCommon

#### final class BCodeAsmCommon[G <: Global] extends AnyRef

This trait contains code shared between GenBCode and GenASM that depends on types defined in the compiler cake (Global).

Source
  BCodeAsmCommon.scala

Linear Supertypes
AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. BCodeAsmCommon
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new BCodeAsmCommon(global: G)

### Type Members

1. #### final case class EnclosingMethodEntry(owner: String, name: String, methodDescriptor: String) extends Product with Serializable

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from BCodeAsmCommon[G] to any2stringadd[BCodeAsmCommon[G]] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (BCodeAsmCommon[G], B)

   Implicit information
     This member is added by an implicit conversion from BCodeAsmCommon[G] to ArrowAssoc[BCodeAsmCommon[G]] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

6. #### lazy val AnnotationRetentionPolicyClassValue: G.Symbol

7. #### lazy val AnnotationRetentionPolicyModule: G.Symbol

8. #### lazy val AnnotationRetentionPolicyRuntimeValue: G.Symbol

9. #### lazy val AnnotationRetentionPolicySourceValue: G.Symbol

10. #### val ExcludedForwarderFlags: Long

11. #### final def asInstanceOf[T0]: T0

    Definition Classes
      Any

12. #### def clone(): AnyRef

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

13. #### def enclosingMethodAttribute(classSym: G.Symbol, classDesc: (G.Symbol) ⇒ String, methodDesc: (G.Symbol) ⇒ String): Option[EnclosingMethodEntry]

    Data for emitting an EnclosingMethod attribute.

    Data for emitting an EnclosingMethod attribute. None if `classSym` is a member class (not an anonymous or local class). See doc in BTypes.

    The class is parametrized by two functions to obtain a bytecode class descriptor for a class symbol, and to obtain a method signature descriptor fro a method symbol. These function depend on the implementation of GenASM / GenBCode, so they need to be passed in.

14. #### def ensuring(cond: (BCodeAsmCommon[G]) ⇒ Boolean, msg: ⇒ Any): BCodeAsmCommon[G]

    Implicit information
      This member is added by an implicit conversion from BCodeAsmCommon[G] to Ensuring[BCodeAsmCommon[G]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

15. #### def ensuring(cond: (BCodeAsmCommon[G]) ⇒ Boolean): BCodeAsmCommon[G]

    Implicit information
      This member is added by an implicit conversion from BCodeAsmCommon[G] to Ensuring[BCodeAsmCommon[G]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

16. #### def ensuring(cond: Boolean, msg: ⇒ Any): BCodeAsmCommon[G]

    Implicit information
      This member is added by an implicit conversion from BCodeAsmCommon[G] to Ensuring[BCodeAsmCommon[G]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

17. #### def ensuring(cond: Boolean): BCodeAsmCommon[G]

    Implicit information
      This member is added by an implicit conversion from BCodeAsmCommon[G] to Ensuring[BCodeAsmCommon[G]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

18. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

19. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

20. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

21. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from BCodeAsmCommon[G] to StringFormat[BCodeAsmCommon[G]] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

22. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

23. #### val global: G

24. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

25. #### def isAnonymousOrLocalClass(classSym: G.Symbol): Boolean

    True if `classSym` is an anonymous class or a local class.

    True if `classSym` is an anonymous class or a local class. I.e., false if `classSym` is a member class. This method is used to decide if we should emit an EnclosingMethod attribute. It is also used to decide whether the "owner" field in the InnerClass attribute should be null.

26. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

27. #### def isOriginallyStaticOwner(sym: G.Symbol): Boolean

    This is basically a re-implementation of sym.isStaticOwner, but using the originalOwner chain.

    This is basically a re-implementation of sym.isStaticOwner, but using the originalOwner chain.

    The problem is that we are interested in a source-level property. Various phases changed the symbol's properties in the meantime, mostly lambdalift modified (destructively) the owner. Therefore, `sym.isStatic` is not what we want. For example, in object T { def f { object U } } the owner of U is T, so UModuleClass.isStatic is true. Phase travel does not help here.

28. #### def isRuntimeVisible(annot: G.AnnotationInfo): Boolean

29. #### def memberClassesOf(classSymbol: G.Symbol): List[G.Symbol]

    The member classes of a class symbol.

    The member classes of a class symbol. Note that the result of this method depends on the current phase, for example, after lambdalift, all local classes become member of the enclosing class.

30. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

31. #### final def notify(): Unit

    Definition Classes
      AnyRef

32. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

33. #### def shouldEmitAnnotation(annot: G.AnnotationInfo): Boolean

    Whether an annotation should be emitted as a Java annotation .initialize: if 'annot' is read from pickle, atp might be un-initialized

34. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

35. #### def toString(): String

    Definition Classes
      AnyRef → Any

36. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

37. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

38. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

39. #### def →[B](y: B): (BCodeAsmCommon[G], B)

    Implicit information
      This member is added by an implicit conversion from BCodeAsmCommon[G] to ArrowAssoc[BCodeAsmCommon[G]] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from BCodeAsmCommon[G] to any2stringadd[BCodeAsmCommon[G]]

### Inherited by implicit conversion StringFormat from BCodeAsmCommon[G] to StringFormat[BCodeAsmCommon[G]]

### Inherited by implicit conversion Ensuring from BCodeAsmCommon[G] to Ensuring[BCodeAsmCommon[G]]

### Inherited by implicit conversion ArrowAssoc from BCodeAsmCommon[G] to ArrowAssoc[BCodeAsmCommon[G]]

### Ungrouped